import { createServer } from 'src/server';
import { addRoutes } from 'src/routes';
import * as config from 'web-api.config';

const main = (serverConfig: typeof config) => {
  const server = createServer();
  addRoutes(server);
  server.listen(serverConfig.meta.port, serverConfig.meta.address, (err) => {
    if (err) {
      server.log.error(err.message);
      process.exit(1);
    }
  });
};

main(config);
