import {
  beforeEach,
  describe,
  expect,
  it,
  vi,
} from 'vitest';
import { generate } from '@theoryofnekomata/oblique-strategies-core';
import { CardService, CardServiceImpl } from '../service';

vi.mock('@theoryofnekomata/oblique-strategies-core');

describe('CardService', () => {
  let cardService: CardService;

  beforeEach(() => {
    cardService = new CardServiceImpl();
  });

  describe('generate', () => {
    it('returns a random card from default set', () => {
      cardService.generate();
      expect(generate).toBeCalled();
    });

    it('returns a random card from custom set', () => {
      cardService.generate(['default', 'text:hello|world']);
      expect(generate).toBeCalledWith(['default', 'text:hello|world']);
    });
  });
});
